<?php

/** part of the ISPProtect Ban Daemon (www.ispprotect.com) **/

$ispp_bd_checks = array(
	array(
		'regex' => '/(GLOBALS|REQUEST)(=|\\[|%%)/',
	),
	array(
		'text' => '(function(',
	),
	array(
		'regex' => '/(eval|base64_decode|str_rot13|gzinflate|move_uploaded_file)\s*\(/'
	),
	array(
		'regex' => '/\/\*[A-Za-z0-9 ]{0,2}\*\//'
	),
	array(
		'regex' => '/\\\\x00|\\x00/'
	)
);

$hit = false;
if(isset($_SERVER['REQUEST_METHOD']) && $_SERVER['REQUEST_METHOD'] === 'POST') {
	// check contents
	if(!isset($_POST) || empty($_POST)) {
		//error_log('[ISPP_BANDAEMON] empty POST request');
	} else {
		foreach($_POST as $key => $value) {
			if(is_array($value)) continue;
			for($i = 0; $i < count($ispp_bd_checks); $i++) {
				$check = $ispp_bd_checks[$i];
				if((isset($check['regex']) && preg_match($check['regex'], $value))
					|| (isset($check['text']) && strpos($value, $check['text']) !== false)) {
					$uri = isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : '';
					$host = isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : '';
					$pos = strpos($uri, '?');
					if($pos !== false) $uri = substr($uri, 0, $pos);
					
					$value = preg_replace('/\\\\x00|\\x00/', '(null)', $value);
					
					error_log('[ISPP_BANDAEMON] suspect POST request to ' . $host . $uri . ' in key ' . $key . ': ' . $value . ' - UserAgent: ' . (isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '(unknown)'));
					$hit = true;
					break;
				}
			}
		}
	}
}

if($hit == false && isset($_GET) && !empty($_GET)) {
	foreach($_GET as $key => $value) {
		if(is_array($value)) continue;
		for($i = 0; $i < count($ispp_bd_checks); $i++) {
			$check = $ispp_bd_checks[$i];
			if((isset($check['regex']) && preg_match($check['regex'], $value))
				|| (isset($check['text']) && strpos($value, $check['text']) !== false)) {
				$uri = isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : '';
				$host = isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : '';
				$pos = strpos($uri, '?');
				if($pos !== false) $uri = substr($uri, 0, $pos);
				
				$value = preg_replace('/\\\\x00|\\x00/', '(null)', $value);
				
				error_log('[ISPP_BANDAEMON] suspect GET request to ' . $host . $uri . ' in key ' . $key . ': ' . $value . ' - UserAgent: ' . (isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '(unknown)'));
				break;
			}
		}
	}
}

unset($ispp_bd_checks);
if(isset($check)) unset($check);
if(isset($value)) unset($value);
if(isset($key)) unset($key);